package zuora.metabuilder;

import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import com.google.common.base.Strings;


public class Meta {

	public static String c_ColumnNameAnnotationProperty = "@Column";
	public static String c_ManyOneAnnotationProperty    = "@ManyToOne";
	public static String c_TypeAnnotationProperty       = "@Type";
	public static String c_ManyOneClassProperty    		= "class";
	public static String c_NameProperty    				= "name";
	public static String c_TypeProperty    				= "type";
	
		
	// Resolution State of the Meta Element
	enum State { 
		FoundInDB(1), 
		ResolvedByAnnotation(2), 
		ResolvedByXML(3);
		
		private int state;
		
		State(int state) {
			this.state = state;
		}
		
		public String toString() {
			switch (state) {
			case 1:  return "DB"; 
			case 2:  return "Annotation"; 
			case 3:  return "XML";
			default: return "<unknown>";
			}
		}
	}

	// Typedef related information
	public static class Typedef {
		String name;
		String clazz;
		Map<String, String> params = new HashMap<>();
		public Typedef(String name, String clazz) {
			this.name = name;
			this.clazz = clazz;
		}
	}

	// Table Related Information
	public static class TableInfo {
		String tableName;
		Boolean isTableNameAutoGenerated = false;
		String prefix;
		String canonicalName;
		String javaClass;
		String source;
		State state;

		Set<String> pkColumns = new HashSet<>();
		Map<String, ColumnInfo> colMap = new HashMap<>();
		
		public TableInfo(String tableName, String source) {
			this.tableName = tableName;
			this.source = source;
			canonicalizeName();
			state = State.FoundInDB;
		}

		private void canonicalizeName() {
			if (tableName.startsWith("zb_") ||
				tableName.startsWith("zo_") || 
				tableName.startsWith("zr_") || 
				tableName.startsWith("zf_") || 
				tableName.startsWith("ar_")) {
				this.prefix = tableName.substring(0, 2);
				this.canonicalName = tableName.substring(3); 
			}
			else 
				this.canonicalName = tableName; 
		}
		
		public String toString() {
			Integer maxColLength = colMap.values().stream().map(x -> x.colName.length()).max(Integer::compare).get();
			
			List<ColumnInfo> colInfoList = colMap.values().stream().collect(Collectors.toList());
			Collections.sort(colInfoList, (x, y) -> x.colName.compareTo(y.colName));
			String colPrint = colInfoList
									.stream()
									.map(x -> x.toFixedString(maxColLength))
									.collect(Collectors.joining("\n\t"));
			String print = String.format("[%s]:{%s}\n\t%s", 
					this.tableName, 
					this.source, 
					colPrint);
			return print;
		} 
	}
	
	public static class ColumnInfo {
		String      tableName;
		String      colName;
		String		colNameInDB;
		String      colType;
		Integer     colPos;
		Integer     colNameLen;
		Boolean     isPrimaryKey = false;
		Boolean		isNullable = true;
		Integer		length = 0;
		String      javaClass;
		Boolean		isNameSpecified = false;
		String      rawJavaClass = null;
		
		ColumnInfo  fkTo = null;
		State       state;
		Map<String, Map<String, Object>> annotations;
		
		private ColumnInfo() {
		}
		
		public ColumnInfo(String tableName, String colName, String javaClass, Map<String, Map<String, Object>> annotations) {
			this.tableName   = tableName;
			this.colName     = colName;
			this.javaClass   = javaClass;
			this.annotations = annotations;
		}
		
		public ColumnInfo(String tableName, String colName, String colType, Integer colPos, Boolean isPrimaryKey) {
			this.tableName    = tableName;
			this.colName      = colName;
			this.colType      = colType;
			this.colPos       = colPos;
			this.colNameLen   = colName.length() + 1;
			this.isPrimaryKey = isPrimaryKey;
			this.state        = State.FoundInDB;
			
			if (Strings.isNullOrEmpty(colType))
				Utilities.Debug();
		}
		
		public String toString() {
			//return String.format("%s \t %s {%s}", colName, colType, state);
			return String.format("(%s:%s)", colName, 
					!Strings.isNullOrEmpty(colType) ? colType :
					javaClass);
		}
		
		public ColumnInfo clone() {
			ColumnInfo ret = new ColumnInfo();
			ret.tableName = this.tableName;
			ret.colName = this.colName;
			ret.colType = this.colType;
			ret.colPos = this.colPos;
			ret.colNameLen = this.colNameLen;
			ret.isPrimaryKey = this.isPrimaryKey;
			ret.isNullable = this.isNullable;
			ret.length = this.length;
			ret.javaClass = this.javaClass;
			ret.fkTo = this.fkTo;
			ret.state = this.state;
			ret.annotations = this.annotations;
			ret.isNameSpecified = this.isNameSpecified;
			return ret;
		}
		
		
		public String toFixedString(Integer width) {
			StringBuilder sb = new StringBuilder();
			String format = String.format("%%-%ds", width);
			sb.append(String.format(format, colName));
			sb.append('\t');
			sb.append(colType);
			sb.append(" (");
			sb.append(javaClass);
			sb.append(")");
			if (isPrimaryKey)
				sb.append(" [PK]");
			if (fkTo != null) {
				sb.append(String.format(" [FK]:(%s,%s) ", fkTo.tableName, fkTo.colName));
			}
			return sb.toString();
		}
	} 

	Map<String, TableInfo> 		 tableMap       = new HashMap<>();
	Map<String, TableInfo>		 classMap       = new HashMap<>();
	Map<String, List<TableInfo>> viewMap		= new HashMap<>();
	Map<String, Set<String>>	 colTableSetMap = new HashMap<>();
}
